// Copyright (c) 2016 Douglas Miller
import java.io.*;
import java.util.Properties;

public class H19Properties extends Properties
{
	static final long serialVersionUID = 198900000002L;

	// 'model' is "89", "19", etc.
	public H19Properties(String model, String[] args) {
		super();
		File f;
		String config;
		config = System.getenv("V" + model + "_CONFIG");
		if (config == null) {
			config = "v" + model + "rc";
			f = new File(config);
			if (f.exists()) {
				config = f.getAbsolutePath();
			} else {
				config = System.getProperty("user.home") + "/." + config;
			}
		}
		// TODO: also allow model property to be set.
		// (others?)
		for (String arg : args) {
			f = new File(arg);
			if (f.exists()) {
				config = f.getAbsolutePath();
				break;
			}
		}
		try {
			FileInputStream cfg = new FileInputStream(config);
			setProperty("configuration", config);
			load(cfg);
			cfg.close();
		} catch(Exception ee) {
			config = null;
		}
	}
}
