// Copyright (c) 2016 Douglas Miller
import java.io.*;
import java.util.Arrays;
import java.util.Vector;

class H89ResponseTee implements Runnable {
	private String resp;
	private InputStream _is;
	OutputStream _os;
	java.util.concurrent.LinkedBlockingDeque<String> respQue;

	public H89ResponseTee(InputStream is, OutputStream os) {
		_is = is;
		_os = os;
		//_op = op;
		resp = new String();
		respQue = new java.util.concurrent.LinkedBlockingDeque<String>();
		Thread t = new Thread(this);
		t.start();
	}

	public Vector<String> waitResponse() {
		Vector<String> sv = new Vector<String>();
		try {
			String s = respQue.take();
			if (s.startsWith("ok ")) {
				sv.add("ok");
				sv.addAll(Arrays.asList(s.substring(3).split(";")));
				return sv;
			} else {
				sv.add(s);
				return sv;
			}
		} catch (Exception ee) {
			sv.add("error I/O");
			return sv;
		}
	}

	public void run() {
		int c;
		while (true) {
			try {
				c = _is.read();
			} catch (Exception ee) {
				break;
			}
			if ((c & 0x80) != 0) {
				try {
					_os.write(c & 0x7f);
					_os.flush();
				} catch (Exception ee) {
					break;
				}
			} else if (c == 0x0a) {
				// pass along response to someone...
				respQue.add(resp);
				resp = new String();
			} else {
				resp += (char)c;
			}
		}
	}
}
