// Copyright (c) 2016 Douglas Miller
import java.io.*;

public class V89JNI extends InputStream {
	static {
		try {
			System.loadLibrary("V89JNI"); // Load native library at runtime
		} catch (UnsatisfiedLinkError ee) {
			System.err.println("Failed to load library V89JNI.");
			System.err.println("    Try adding '-Djava.library.path=.' to command line or");
			System.err.println("    ensure that the library exists in current directory.");
			//ee.printStackTrace();
			System.exit(1);
		}
	}
	// perhaps there's a better way. big overhead for DEQueue element of one int.
	java.util.concurrent.LinkedBlockingDeque<Integer> fifo;

	public V89JNI() {
		fifo = new java.util.concurrent.LinkedBlockingDeque<Integer>();
	}

	public native void startV89(String[] args);
	public native String doCmd(String cmd);
	public native void doChar(int ch);

	public void putChar(int c) {
		fifo.add(c);
	}

	//////// InputStream Implementation ////////
	public int read() {
		try {
			int c = fifo.take();
			return c;
		} catch(Exception ee) {
			return -1;
		}
	}

	public int available() {
		return fifo.size();
	}
}
